<div class="mb-3">
  <h3
    *ngIf="name"
    markdown
    [content]="name"
    [context]="context"
    [enumerator]="enumerator"
    [required]="block.required"
  ></h3>
  <p *ngIf="description" class="text-secondary" markdown [content]="description" [context]="context"></p>
  <div [ngClass]="placeholder ? 'form-floating' : ''">
    <input
      #ref
      type="text"
      class="form-control"
      [id]="block.key()"
      [required]="block.required"
      [placeholder]="placeholder"
      [attr.maxlength]="block.maxLength || null"
      [attr.aria-describedby]="explanation && block.key('explanation')"
      [autocomplete]="block.props.autoComplete ? block.props.autoComplete : 'off'"
      [attr.list]="block.props.suggestions && block.key('list')"
      [attr.inputmode]="block.props.autoComplete === 'tel' ? 'tel' : 'text'"
      [(ngModel)]="block.textSlot.value"
      (focus)="block.onFocus(ref)"
      (blur)="block.onBlur(ref)"
    />
    <label *ngIf="placeholder" [for]="block.key()">{{ placeholder }}</label>
  </div>
  <datalist *ngIf="block.props.suggestions" [id]="block.key('list')">
    <option *ngFor="let suggestion of block.props.suggestions" [value]="suggestion.name"></option>
  </datalist>
  <div
    *ngIf="explanation"
    class="form-text"
    [id]="block.key('explanation')"
    markdown
    [content]="explanation"
    [context]="context"
  ></div>
</div>
